unit Demo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, StrUtils;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    chkCode39: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    chkCode128: TCheckBox;
    chkEAN128: TCheckBox;
    chkEAN13: TCheckBox;
    chkEAN8: TCheckBox;
    chkUPCA: TCheckBox;
    chkUPCE: TCheckBox;
    chkIT25: TCheckBox;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    txtThreshold: TEdit;
    cbxQuietZone: TComboBox;
    cbxMinBarHeight: TComboBox;
    cbxMaxBarHeight: TComboBox;
    btnScanningOptions: TButton;
    GroupBox2: TGroupBox;
    Label14: TLabel;
    Label15: TLabel;
    txtWidth: TEdit;
    txtHeight: TEdit;
    Label16: TLabel;
    txtImgPages: TEdit;
    Label17: TLabel;
    cbxPages: TComboBox;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    txtRLeft: TEdit;
    txtRTop: TEdit;
    txtRWidth: TEdit;
    txtRHeight: TEdit;
    btnImageInfo: TButton;
    memBarcodeInfo: TMemo;
    btnOpen: TButton;
    btnScan: TButton;
    btnClose: TButton;
    OD: TOpenDialog;
    procedure btnCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnScanningOptionsClick(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
    procedure btnScanClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnImageInfoClick(Sender: TObject);
    procedure cbxPagesChange(Sender: TObject);
  private
    function GetImgFormat(ImgName: String): Integer;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CheckEAN8: boolean;
  CheckEAN13: boolean;
  CheckIT25: boolean;
  CheckUPCE: boolean;
  CheckUPCA: boolean;
  CheckEAN128: boolean;
  CheckCode128: boolean;
  CheckCode39: boolean;
  Threshold: Integer;
  QuietZone: Double;
  MinBarHeight: Double;
  MaxBarHeight: Double;

  ImgFormat: Integer;
  PageOption: Integer;
  RLeft: Integer;
  RTop: Integer;
  RRight: Integer;
  RBottom: Integer;
  ImgWidth: Integer;
  ImgHeight: Integer;

  Form1: TForm1;

function De1DInit(): Integer
        stdcall; far; external 'Decode1D.dll' name 'De1DInit'

function De1DSetkey(Key: PChar): Integer
        stdcall; far; external 'Decode1D.dll' name 'De1DSetKey'

function De1DCleanUp(): Integer
        stdcall; far; external 'Decode1D.dll' name 'De1DCleanUp'

function De1DGetCount(): Integer
        stdcall; far; external 'Decode1D.dll' name 'De1DGetCount'

function De1DGetType(CodeIndex: Integer): Integer
        stdcall; far; external 'Decode1D.dll' name 'De1DGetType'

function De1DGetStrLen(CodeIndex: Integer): Integer
        stdcall; far; external 'Decode1D.dll' name 'De1DGetStrLen'

function De1DGetCharAt(CodeIndex: Integer; CharIndex: Integer): Integer
        stdcall; far; external 'Decode1D.dll' name 'De1DGetCharAt'

function De1DGetRect(CodeIndex: Integer; var P1: DWORD; var P2: DWORD;
        var P3: DWORD; var P4: DWORD): Integer
        stdcall; far; external 'Decode1D.dll' name 'De1DGetRect'

function De1DLoadFromMem(var buffer; Size: DWORD; ImgFormat : Integer): Integer
        stdcall; far; external 'Decode1D.dll' name 'De1DLoadFromMem'

function De1DLoadFromFile(FileName: String; ImgFormat: Integer): Integer
        stdcall; far; external 'Decode1D.dll' name 'De1DLoadFromFile'

function De1DGetNumOfPages(): Integer
        stdcall; far; external 'Decode1D.dll' name 'De1DGetNumOfPages'

function De1DSetPage(PageIndex: Integer): Integer
        stdcall; far; external 'Decode1D.dll' name 'De1DSetPage'

function De1DGetImgSize(var Width: Integer; var Height: Integer): Integer
        stdcall; far; external 'Decode1D.dll' name 'De1DGetImgSize'

function De1DSetThreshold(Threshold: Integer): Integer
        stdcall; far; external 'Decode1D.dll' name 'De1DSetThreshold'

function De1DSetRegion(Left: Integer; Top: Integer; Right: Integer; Bottom: Integer): Integer
        stdcall; far; external 'Decode1D.dll' name 'De1DSetRegion'

function De1DSetLimit(QuietZoneSize: Double; MinBarHeight: Double; MaxBarHeight: Double): Integer
        stdcall; far; external 'Decode1D.dll' name 'De1DSetLimit'

function De1DScanType(CodeType: Integer; Enabled: Integer): Integer
        stdcall; far; external 'Decode1D.dll' name 'De1DScanType'

function De1DScan(): Integer
        stdcall; far; external 'Decode1D.dll' name 'De1DScan'


implementation

{$R *.dfm}

procedure TForm1.btnCloseClick(Sender: TObject);
begin
   Application.Terminate();
end;

function TForm1.GetImgFormat(ImgName: String): Integer;
var
   position: Integer;
   ext_name: String;
   ext_name_len: Integer;
begin
   position := Pos('.', ImgName);
   ext_name_len := Length(ImgName) - position;
   ext_name := LowerCase(RightStr(ImgName, ext_name_len));

   if CompareStr(ext_name, 'bmp') = 0 then
      Result := 1
   else if CompareStr(ext_name, 'gif') = 0 then
      Result := 2
   else if CompareStr(ext_name, 'ico') = 0 then
      Result := 3
   else if (CompareStr(ext_name, 'jpg') = 0) or (CompareStr(ext_name, 'jpeg') = 0) then
      Result := 4
   else if CompareStr(ext_name, 'png') = 0 then
      Result := 5
   else if (CompareStr(ext_name, 'tif') = 0) or (CompareStr(ext_name, 'tiff') = 0) then
      Result := 6
   else if CompareStr(ext_name, 'wmf') = 0 then
      Result := 7
   else
      Result := -1;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
   chkCode39.Checked := true;
   chkCode128.Checked := true;
   chkEAN128.Checked := true;
   chkEAN13.Checked := true;
   chkEAN8.Checked := true;
   chkUPCA.Checked := true;
   chkUPCE.Checked := true;
   chkIT25.Checked := true;

   cbxQuietZone.ItemIndex := 1;
   cbxMinBarHeight.ItemIndex := 0;
   cbxMaxBarHeight.ItemIndex := 0;

   CheckCode39 := true;
   CheckCode128 := true;
   CheckEAN128 := true;
   CheckEAN13 := true;
   CheckEAN8 := true;
   CheckUPCA := true;
   CheckUPCE := true;
   CheckIT25 := true;
   Threshold := 128;
   QuietZone := 10;
   MinBarHeight := 1;
   MaxBarHeight := 5;

   memBarcodeInfo.Text := '';

   // Make sure De1DInit is called before you scan the barcode images
   // This function call is mandatory.
   De1DInit();
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   // Make sure De1DCleanUp is called after you finish scanning all barcode images
   // This function call is mandatory to free the memory.
   De1DCleanUp();
end;

procedure TForm1.btnScanningOptionsClick(Sender: TObject);
begin

   if chkCode39.Checked then
      // enable scanning code39
      CheckCode39 := true
   else
      // disable scanning code39
      CheckCode39 := false;

   if chkCode128.Checked then
      // enable scanning code128
      CheckCode128 := true
   else
      // disable scanning code129
      CheckCode128 := false;

   if chkEAN128.Checked then
      // enable scanning EAN128
      CheckEAN128 := true
   else
      // disable scanning EAN128
      CheckEAN128 := false;

   if chkEAN13.Checked then
      // enable scanning EAN13
      CheckEAN13 := true
   else
      // disable scanning EAN13
      CheckEAN13 := false;

   if chkEAN8.Checked then
      // enable scanning EAN8
      CheckEAN8 := true
   else
      // disable scanning EAN8
      CheckEAN8 := false;

   if chkUPCA.Checked then
      // enable scanning UPCA
      CheckUPCA := true
   else
      // disable scanning UPCA
      CheckUPCA := false;

   if chkUPCE.Checked then
      // enable scanning UPCE
      CheckUPCE := true
   else
      // disable scanning UPCE
      CheckUPCE := false;

   if chkIT25.Checked then
      // enable scanning Interleaved 25
      CheckIT25 := true
   else
      // disable scanning Interleaved 25
      CheckIT25 := false;

   Threshold := StrToInt(txtThreshold.Text);
   QuietZone := StrToFloat(cbxQuietZone.Text);
   MinBarHeight := StrToFloat(cbxMinBarHeight.Text);
   MaxBarHeight := StrToFloat(cbxMaxBarHeight.Text);
end;

procedure TForm1.btnImageInfoClick(Sender: TObject);
var
   ErrorMsg : String;
begin

   ErrorMsg := '';

   // Region's left value
   RLeft := StrToInt(txtRLeft.Text);
   if (RLeft < 0) or (RLeft >= ImgWidth) then
   begin
        ErrorMsg := ErrorMsg + 'Left value must be between 0 and image width minus ' + Chr(13) + Chr(10);
	RLeft := 0;
   end;

   // Region's top value
   RTop := StrToInt(txtRTop.Text);
   if (RTop < 0) or (RTop >= ImgHeight) then
   begin
        ErrorMsg := ErrorMsg + 'Left value must be between 0 and image height minus 1' + Chr(13) + Chr(10);
	RTop := 0;
   end;

   // Region's right value
   RRight := RLeft + StrToInt(txtRWidth.Text) - 1;
   if (RRight < RLeft) or (RRight >= ImgWidth) then
   begin
        ErrorMsg := ErrorMsg + 'Right value must be between left value and image width minus 1' + Chr(13) + Chr(10);
	RRight := ImgWidth - 1;
   end;

   // Region's bottom value
   RBottom := RTop + StrToInt(txtRHeight.Text) - 1;
   if (RBottom < RTop) or (RBottom >= ImgHeight) then
   begin
        ErrorMsg := ErrorMsg + 'Bottom value must be between top value and image height minus 1' + Chr(13) + Chr(10);
	RBottom := ImgHeight - 1;
   end;

   if Length(ErrorMsg) > 0 then
        ShowMessage(ErrorMsg);
end;


procedure TForm1.btnOpenClick(Sender: TObject);
var
   file_name : String;
   I : Integer;
   result : Integer;
   p : Integer;
   w, h : Integer;

begin
   OD.Title := 'Open File';
   if OD.Execute then
   begin
      // get file name
      file_name := OD.FileName;

      // get image format info
      ImgFormat := GetImgFormat(file_name);

      if ImgFormat = -1 then
        // invalid image format
        exit;

      result := De1DLoadFromFile(file_name, ImgFormat);

      if result = 1 then
      begin
        if (ImgFormat = 2) Or (ImgFormat = 6) then
        begin
          // TIF or GIF file

          // how many pages
          P := De1DGetNumOfPages();
          txtImgPages.Text := IntToStr(p);

          cbxPages.Clear();

          // update page list
          For I := 0 to (P - 1) do
            cbxPages.Items.Add(IntToStr(I));

          cbxPages.ItemIndex := 0;

          // choose 1st page
          result := De1DSetPage(0);

          if result = 1 Then
          begin
            // image size
            result := De1DGetImgSize(w, h);

            txtWidth.Text := IntToStr(w);
            txtRWidth.Text := IntToStr(w);

            txtHeight.Text := IntToStr(h);
            txtRHeight.Text := IntToStr(h);

            txtRLeft.Text := '0';
            txtRTop.Text := '0';

            RLeft := 0;
            RTop := 0;
            RRight := w - 1;
            RBottom := h - 1;
            ImgWidth := w;
            ImgHeight := h;
          end;
        end
        else
        begin
           cbxPages.Clear();
           txtImgPages.Text := '1';

           // other image formats
           // image size
           result := De1DGetImgSize(w, h);

           txtWidth.Text := IntToStr(w);
           txtRWidth.Text := IntToStr(w);

           txtHeight.Text := IntToStr(h);
           txtRHeight.Text := IntToStr(h);

           txtRLeft.Text := '0';
           txtRTop.Text := '0';

           RLeft := 0;
           RTop := 0;
           RRight := w - 1;
           RBottom := h - 1;
           ImgWidth := w;
           ImgHeight := h;
       end;
       btnImageInfo.Enabled := true;
    end
    else
       btnImageInfo.Enabled := false;
   end;
end;

procedure TForm1.btnScanClick(Sender: TObject);
var
  result : Integer;
  BarcodeInfo : String;
  CrLf : String;
  I, J : Integer;
  X, Y : Integer;
  BarcodeType : Integer;
  Point : array[0..3] of DWORD;
  StrLen : Integer;
  count : Integer;
  OneChar : Byte;

begin

  // enable/disable scanning Code39
  if CheckCode39 then
    result := De1DScanType(0, 1)
  else
    result := De1DScanType(0, 0);

  // enable/disable scanning Code128
  if CheckCode128 then
    result := De1DScanType(1, 1)
  else
    result := De1DScanType(1, 0);

  // enable/disable scanning EAN128
  if CheckEAN128 then
    result := De1DScanType(2, 1)
  else
    result := De1DScanType(2, 0);

  // enable/disable scanning EAN13
  if CheckEAN13 then
    result := De1DScanType(3, 1)
  else
    result := De1DScanType(3, 0);

  // enable/disable scanning EAN8
  if CheckEAN8 then
    result := De1DScanType(4, 1)
  else
    result := De1DScanType(4, 0);

  // enable/disable scanning UPCA
  if CheckUPCA then
    result := De1DScanType(5, 1)
  else
    result := De1DScanType(5, 0);

  // enable/disable scanning UPCE
  if CheckUPCE then
    result := De1DScanType(6, 1)
  else
    result := De1DScanType(6, 0);

  // enable/disable scanning Interleaved 25
  if CheckIT25 then
    result := De1DScanType(7, 1)
  else
    result := De1DScanType(7, 0);

  // For full version library, pass the 10-digit license key to this function
  // Sample code:
  // result := De1DSetKey('123456-7890');
  result := De1DSetkey('DEMO');

  result := De1DSetThreshold(Threshold);

  result := De1DSetLimit(QuietZone, MinBarHeight, MaxBarHeight);

  result := De1DSetRegion(RLeft, RTop, RRight, RBottom);

  result := De1DScan();

  count := De1DGetCount();

  if count > 0 then
  begin
    CrLf := Chr(13) + Chr(10);
    if count = 1 then
      BarcodeInfo := '1 Barcode Found' + CrLf
    else
      BarcodeInfo := IntToStr(count) + ' Barcodes Found' + CrLf;

    for I := 1 to count do
    begin
      BarcodeInfo := BarcodeInfo + '[Barcode ' + IntToStr(I) + ']' + CrLf;

      // barcode type
      BarcodeType := De1DGetType(I - 1);
      if BarcodeType = 0 then
        BarcodeInfo := BarcodeInfo + 'Type: Code39' + CrLf
      else if BarcodeType = 1 then
        BarcodeInfo := BarcodeInfo + 'Type: Code128' + CrLf
      else if BarcodeType = 2 then
        BarcodeInfo := BarcodeInfo + 'Type: EAN128' + CrLf
      else if BarcodeType = 3 then
        BarcodeInfo := BarcodeInfo + 'Type: EAN13' + CrLf
      else if BarcodeType = 4 then
        BarcodeInfo := BarcodeInfo + 'Type: EAN8' + CrLf
      else if BarcodeType = 5 then
        BarcodeInfo := BarcodeInfo + 'Type: UPCA' + CrLf
      else if BarcodeType = 6 then
        BarcodeInfo := BarcodeInfo + 'Type: UPCE' + CrLf
      else if BarcodeType = 7 then
        BarcodeInfo := BarcodeInfo + 'Type: Interleaved 25' + CrLf;

      //barcode boundary rectangle
      result := De1DGetRect(I - 1, Point[0], Point[1], Point[2], Point[3]);
      for J := 1 to 4 do
      begin
        X := (Point[J - 1] Shr 16) and $FFFF;
        Y := Point[J - 1] and $FFFF;
        BarcodeInfo := BarcodeInfo + 'Point ' + IntToStr(J) + ': (' + IntToStr(X) + ', ' + IntToStr(Y) + ')' + CrLf;
      end;

      // the string encoded by this barcode
      StrLen := De1DGetStrLen(I - 1);
      BarcodeInfo := BarcodeInfo + 'String length: ' + IntToStr(StrLen) + CrLf;
      BarcodeInfo := BarcodeInfo + 'String: ';
      for J := 0 to (StrLen - 1) do
      begin
        OneChar := De1DGetCharAt(I - 1, J);
        if ((BarcodeType = 1) or (BarcodeType = 2)) and (OneChar >= 201) and (OneChar <= 204) then
          // code128 or EAN128
          // FNC 1, FNC 2, FNC 3 or FNC 4
          BarcodeInfo := BarcodeInfo + 'FNC ' + Chr(OneChar - 200 + Ord('0'))
        else
          BarcodeInfo := BarcodeInfo + Chr(OneChar);
      end;

      BarcodeInfo := BarcodeInfo + CrLf + CrLf;
    end;
    memBarcodeInfo.Text := BarcodeInfo;
  end
  else
    memBarcodeInfo.Text := 'No barcode found.';
end;

procedure TForm1.cbxPagesChange(Sender: TObject);
var
   result : Integer;
   w, h : Integer;
   PageNo : Integer;
begin
   if (ImgFormat = 2) Or (ImgFormat = 6) then
   begin
      // choose a page
      PageNo := cbxPages.ItemIndex;
      De1DSetPage(PageNo);

      // image size
      result := De1DGetImgSize(w, h);

      txtWidth.Text := IntToStr(w);
      txtRWidth.Text := IntToStr(w);

      txtHeight.Text := IntToStr(h);
      txtRHeight.Text := IntToStr(h);

      txtRLeft.Text := '0';
      txtRTop.Text := '0';

      RLeft := 0;
      RTop := 0;
      RRight := w - 1;
      RBottom := h - 1;
      ImgWidth := w;
      ImgHeight := h;
   end;
end;

end.
